/*
 * Created on Sep 19, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package lib.cfg;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Hashtable;

import lib.db.DBManager;
import lib.exceptions.DBManagerException;
import lib.exceptions.ConfigException;

/**
 * @class lib.cfg
 * 
 * Configuration utility
 * 
 * @author Tihomir Lazarov
 * @date   Sep 19, 2004
 */
public class Config {
	
	private Hashtable m_Params = null;
	
	/**
	 * Constructs a Config object
	 * 
	 * @param manager - database manager
	 */
	public Config( DBManager manager )
		throws ConfigException
	{
		try {
			m_Params = new Hashtable( );
			ResultSet result = manager.select( "SELECT * FROM config" );
			while ( result.next( ) ) {
				m_Params.put( result.getString( "Name" ), result.getString( "Value" ) );
			}
		} catch ( DBManagerException e ) {
			throw new ConfigException( "DBManagerException:" + e.getMessage( ), e );
		} catch ( SQLException e ) {
			throw new ConfigException( "SQLException:" + e.getMessage( ), e );
		}
	}
	
	/**
	 * Gets a config parameter value
	 * 
	 * @param szName
	 * 
	 * @return the value of the given parameter szName
	 */
	public String getValue( String szName ) 
	{
		if ( m_Params.containsKey( szName ) ) {
			return ( String )m_Params.get( szName );
		} else {
			return "";
		}
	}
}
