package lib.cfg;

/**
 * @class lib.cfg
 * 
 * Constants
 * 
 * @author Tihomir Lazarov
 * @date   Sep 30, 2004
 */
public class Constants {
	/* -- Global configuration parameters ---------------------------------- */
	public static final String PARAM_VIEWER_WIDTH			= "ViewerWidth";
	public static final String PARAM_VIEWER_HEIGHT			= "ViewerHeight";
	public static final String PARAM_MAPS_DIRECTORY 		= "MapsDirectory";
	public static final String PARAM_ICONS_DIRECTORY		= "IconsDirectory";
	public static final String PARAM_ICONS_WEB_DIRECTORY	= "IconsWebDirectory";
	public static final String PARAM_PREFERRED_AREA_WIDTH = "PreferredAreaWidth";
	public static final String PARAM_PREFERRED_AREA_HEIGHT= "PreferredAreaHeight";
	public static final String PARAM_RESET_MAP				= "ResetMap";
	public static final String PARAM_EVENT						= "Event";
	public static final String PARAM_X							= "X";
	public static final String PARAM_Y							= "Y";
	public static final String PARAM_INFO_TYPE				= "InfoType";
	public static final String PARAM_MAP_ID					= "MapID";
	public static final String PARAM_SEARCH_QUERY			= "Q";
	public static final String PARAM_LOGIN						= "Login";
	public static final String PARAM_PASSWORD					= "Password";
	public static final String PARAM_SHOW_GRAPH				= "ShowGraph";
	public static final String PARAM_SEARCH_IN_NAME			= "InName";
	public static final String PARAM_SEARCH_IN_DESCRIPTION= "InDesc";
	public static final String PARAM_SEARCH_IN_URL			= "InURL";
	public static final String PARAM_SEARCH_ICON_IDS		= "IconIDs";
	public static final String PARAM_ZOOM_LEVEL				= "ZoomLevel";
	
	// These two below are used for finding the shortest paths between two areas
	public static final String PARAM_SEARCH_AREA1			= "A1";
	public static final String PARAM_SEARCH_AREA2			= "A2";
	
	/* -- Area manipulation ------------------------------------------------ */
	public static final String AREA_PARAM_POSITION			= "Position";
	public static final int		AREA_POSITION_NONE			= 1;
	public static final int		AREA_POSITION_CENTERED		= 2;
	
	public static final String AREA_PARAM_UNIQUE_ID			= "ID";
	
	/* -- Area attributes -------------------------------------------------- */
	public static final String AREA_ATTRIBUTE_X				= "X";
	public static final String AREA_ATTRIBUTE_Y				= "Y";
	public static final String AREA_ATTRIBUTE_WIDTH			= "Width";
	public static final String AREA_ATTRIBUTE_HEIGHT		= "Height";
	public static final String AREA_ATTRIBUTE_NAME			= "Name";
	public static final String AREA_ATTRIBUTE_DESCRIPTION	= "Description";
	public static final String AREA_ATTRIBUTE_URL			= "URL";
	public static final String AREA_ATTRIBUTE_ICON_ID		= "IconID";
	public static final String AREA_ATTRIBUTE_ZINDEX		= "ZIndex";
	public static final String AREA_ATTRIBUTE_POLICY		= "Policy";
	public static final String AREA_ATTRIBUTE_SUB_MAP		= "SubMap";
	
	/* -- Event types ------------------------------------------------------ */
	public final static String EVENT_ON_CLICK 				= "OnClick";
	public final static String EVENT_ON_ZOOM_IN				= "OnZoomIn"; 
	public final static String EVENT_ON_ZOOM_OUT				= "OnZoomOut";
	public final static String EVENT_ON_MAX_ZOOM_REACHED 	= "OnMaxZoomReached";
	public final static String EVENT_ON_MIN_ZOOM_REACHED  = "OnMinZoomReached";
	public final static String EVENT_ON_MOVE_LEFT         = "OnMoveLeft";
	public final static String EVENT_ON_MOVE_RIGHT        = "OnMoveRight";
	public final static String EVENT_ON_MOVE_UP        	= "OnMoveUp";
	public final static String EVENT_ON_MOVE_DOWN      	= "OnMoveDown";
	public final static String EVENT_ON_ZOOM_IN_MOVE		= "OnZoomInMove";
	public final static String EVENT_ON_ZOOM_OUT_MOVE		= "OnZoomOutMove";
	public final static String EVENT_ON_ZOOM_TO				= "OnZoomTo";
	
	/* -- Action types ----------------------------------------------------- */
	public final static String ACTION_CLICK					= "Click";
	public final static String ACTION_ZOOM_IN					= "ZoomIn";
	public final static String ACTION_ZOOM_OUT				= "ZoomOut";
	public final static String ACTION_MOVE_LEFT				= "MoveLeft";
	public final static String ACTION_MOVE_RIGHT				= "MoveRight";
	public final static String ACTION_MOVE_UP					= "MoveUp";
	public final static String ACTION_MOVE_DOWN				= "MoveDown";
	public final static String ACTION_ZOOM_IN_MOVE			= "ZoomInMove";
	public final static String ACTION_ZOOM_OUT_MOVE			= "ZoomOutMove";
	public final static String ACTION_OPEN_URL				= "OpenURL";
	public final static String ACTION_ZOOM_TO					= "ZoomTo";

	/*-- Map navigation ---------------------------------------------------- */
	public final static int TRANSLATION_OFFSET_PERCENTS	= 50;	
	
	/*-- Fetching map information ------------------------------------------ */
	public final static int INFO_TYPE_INIT						= 1;
	public final static int INFO_TYPE_COMMON					= 2;
	public final static int INFO_TYPE_AREA						= 3;
	
	/* -- Database config parameters --------------------------------------- */
	public final static String PARAM_DB_HOST					= "DB_HOST";
	public final static String PARAM_DB_NAME					= "DB_NAME";
	public final static String PARAM_DB_USER					= "DB_USER";
	public final static String PARAM_DB_PASS					= "DB_PASS";
	
	/* -- Session parameter names ------------------------------------------ */
	public final static String SESSION_PARAM_MAP				= "Map";
	public final static String SESSION_PARAM_SNAPSHOT		= "Snapshot";
	public final static String SESSION_PARAM_AUTH			= "Auth";
	
	/* -- Map image -------------------------------------------------------- */
	public final static String DEFAULT_MAP_CONTENT_TYPE	= "image/jpeg";
}
