/*
 * Created on May 14, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package lib.map.base.colors;

import java.awt.Color;

/**
 * @class lib.map.base.HSV
 * 
 * Converts RGB to HSV and vice versa. Uses the built in
 * methods in the java Color class.
 * 
 * @author Tihomir Lazarov
 * @date   May 14, 2005
 */
public class HSV {
	public int hue			= 0;
	public int saturation	= 0;
	public int value		= 0;
	public int red			= 0;
	public int green		= 0;
	public int blue			= 0;

	/**
	 * Converts RGB to HSV
	 * 
	 * @param r - 0..255 value
	 * @param g - 0..255 value
	 * @param b - 0..255 value
	 */
	public void toHSV( int r, int g, int b ) 
	{
		float [] hsbvals = null;
		hsbvals = Color.RGBtoHSB( r, g, b, null );
	
		hue        = ( int ) ( hsbvals[ 0 ] * 360.0f );
		saturation = ( int ) ( hsbvals[ 1 ] * 100.0f );
		value      = ( int ) ( hsbvals[ 2 ] * 100.0f );
	}

	/**
	 * Converts HSV to RGB
	 * @param hue - 0..360 value
	 * @param saturation - 0..100 value
	 * @param value - 0..100 value
	 */
	public void toRGB( int hue, int saturation, int value )
	{
		Color c = new Color( Color.HSBtoRGB( hue / 360.0f, saturation / 100.0f, value / 100.0f ) );
	
		red = c.getRed( );
		green = c.getGreen( );
		blue = c.getBlue( );
	}
}