package lib.map.dynamic.cfg;

import lib.db.DBManager;
import lib.cfg.Config;
import lib.map.dynamic.Icons;

/**
 * @class lib.map.dynamic.cfg.DynamicMapEnvironment
 * 
 * Creates the environment that's needed for the functioning
 * of the dynamic maps
 * 
 * @author Tihomir Lazarov
 */
public class DynamicMapEnvironment {
	private Icons m_Icons			= null;
	private Config m_Config			= null;
	private DBManager m_DBManager = null;
	private int m_iViewerWidth		= 0;
	private int m_iViewerHeight	= 0;
	
	public DynamicMapEnvironment( DBManager manager, Config config, 
	                              Icons icons, 
	                              int iViewerWidth, int iViewerHeight )
	{
		m_DBManager 		= manager;
		m_Config				= config;
		m_Icons				= icons;
		m_iViewerWidth		= iViewerWidth;
		m_iViewerHeight	= iViewerHeight;
	}
	
	public DBManager getDBManager( )
	{
		return m_DBManager;
	}

	public Config getConfig( )
	{
		return m_Config;
	}
	
	public Icons getIcons( )
	{
		return m_Icons;
	}
	
	public int getViewerWidth( )
	{
		return m_iViewerWidth;
	}
	
	public int getViewerHeight( )
	{
		return m_iViewerHeight;
	}
}
