package lib.road;

import java.util.ArrayList;

import lib.map.base.colors.YCrCb;
import lib.map.base.Rectangle;

/**
 * @class lib.road
 * 
 * A simple container for information that is needed
 * in order to start the road recognition, e.g.
 * hue/saturation/value ranges.
 * 
 * @author Tihomir Lazarov
 * @date   May 22, 2005
 */
public class RecognitionInfo {
	public YCrCb ycrcbDelta;
	public ArrayList samplePixels;
	public Rectangle optimizedScanPortion;
	
	public RecognitionInfo( )
	{
		reset( );
	}
	
	public void reset( )
	{
		ycrcbDelta 				= new YCrCb( );
		optimizedScanPortion	= null;
		samplePixels 			= new ArrayList( ); 
	}
}
