package lib.servlets;

import java.io.IOException;
import java.io.ObjectOutputStream;

import javax.servlet.*;

import lib.cfg.Constants;
import lib.comm.MapRequestInfo;
import lib.user.Authentication;
import lib.map.dynamic.DynamicMap;
import lib.map.dynamic.cfg.DynamicMapEnvironment;
import lib.exceptions.AuthenticationException;

/**
 * @class lib.servlets.TempGetInfo
 * 
 * Authenticates the user and stores an authentication flag
 * in the session
 * 
 * @author Tihomir Lazarov
 * @date   Aug 22, 2004
 */
public class Login extends lib.servlets.ZoomMap {
	public void service( ServletRequest request, ServletResponse response )
			throws ServletException 
	{
		try {
			DynamicMap map 				= serviceBegin( request, response );
			DynamicMapEnvironment env	= map.getEnvironment( );
			Authentication auth 			= new Authentication( env.getDBManager( ) );
			
			// Authenticate the login and the password
			String szLogin					= request.getParameter( Constants.PARAM_LOGIN 		);
			String szPassword				= request.getParameter( Constants.PARAM_PASSWORD 	);
			MapRequestInfo info 			= new MapRequestInfo( );
			
			if ( szLogin != null && szPassword != null &&
			     auth.authenticate( szLogin, szPassword ) == true ) {
				auth.setAuthenticated( request );
				info.setLogged( true );
				System.out.println( "Login successful!" );
			} else {
				info.setLogged( false );
				System.out.println( "Login incorrect." );
			}
			// Semd an info object back
			response.setContentType( "application/unknown" );
			ServletOutputStream os 		= response.getOutputStream( );
			ObjectOutputStream objOut 	= new ObjectOutputStream( os );
			objOut.writeObject( info );
			objOut.close( );
		} catch ( AuthenticationException e ) {
			System.out.println( "Authentication exception: " + e.getMessage( ) );
			throw new ServletException( "Authentication exception: " + e.getMessage( ) );
		} catch ( IOException e ) {
			System.out.println( "Authentication: I/O exception: " + e.getMessage( ) );
			throw new ServletException( "Authentication: I/O exception: " + e.getMessage( ) );
		}
	}
	
}
