package lib.servlets;

import java.io.IOException;
import java.io.ObjectOutputStream;

import javax.servlet.*;

import lib.comm.MapRequestInfo;
import lib.user.Authentication;
import lib.map.dynamic.DynamicMap;
import lib.map.dynamic.cfg.DynamicMapEnvironment;

/**
 * @class lib.servlets.TempGetInfo
 * 
 * Authenticates the user and stores an authentication flag
 * in the session
 * 
 * @author Tihomir Lazarov
 * @date   Aug 22, 2004
 */
public class Logout extends lib.servlets.ZoomMap {
	public void service( ServletRequest request, ServletResponse response )
			throws ServletException 
	{
		try {
			DynamicMap map 				= serviceBegin( request, response );
			DynamicMapEnvironment env	= map.getEnvironment( );
			Authentication auth 			= new Authentication( env.getDBManager( ) );

			// Delete the user session for being logged in			
			MapRequestInfo info 			= new MapRequestInfo( );
		
			auth.setLoggedOut( request );
			info.setLogged( false );
			System.out.println( "Logged out." );
			
			// Semd an info object back
			response.setContentType( "application/unknown" );
			ServletOutputStream os 		= response.getOutputStream( );
			ObjectOutputStream objOut 	= new ObjectOutputStream( os );
			objOut.writeObject( info );
			objOut.close( );
		} catch ( IOException e ) {
			System.out.println( "Authentication: I/O exception: " + e.getMessage( ) );
			throw new ServletException( "Authentication: I/O exception: " + e.getMessage( ) );
		}
	}
	
}
