package lib.servlets;

import javax.servlet.*;

import lib.map.dynamic.DynamicMap;
import lib.exceptions.DynamicMapException;
import lib.exceptions.NullMapException;

/**
 * @class lib.servlets
 * 
 * Reloads a map
 * 
 * @author Tihomir Lazarov
 * @date   Aug 22, 2004
 */
public class ReloadMap extends lib.servlets.ZoomMap {
	
	public void service( ServletRequest request, ServletResponse response )
			throws ServletException 
	{
		try {
			DynamicMap map = serviceBegin( request, response );
			
			if ( isLogged( request ) ) {
				map.reload( );
			}
			
			serviceEnd( request, response, map, map.getSnapshot( ) );
			
		} catch ( NullMapException e ) {
			throw new ServletException( e.getMessage( ) );
		} catch ( DynamicMapException e ) {
			throw new ServletException( e.getMessage( ) );
		}
	}
}
