/*
 * Created on Aug 22, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package lib.servlets;

import javax.servlet.*;

import lib.map.dynamic.DynamicMap;
import lib.cfg.Constants;
import lib.exceptions.NullMapException;
import lib.exceptions.DynamicMapException;

/**
 * @class lib.servlets
 * 
 * Removes an area from a map
 * 
 * @author root
 * @date   Aug 22, 2004
 */
public class RemoveArea extends ZoomMap {
	public void service( ServletRequest request, ServletResponse response )
				throws ServletException
	{ 
		try {
			DynamicMap map = serviceBegin( request, response );
		
			if ( isLogged( request ) ) {
				removeArea( request, map );
			} else {
				throw new ServletException( "This operation requires an authentication" );
			}
			serviceEnd( request, response, map, map.getSnapshot( ) );
		} catch ( NullMapException e ) {
			throw new ServletException( e.getMessage( ) );
		} catch ( DynamicMapException e ) {
			throw new ServletException( e.getMessage( ) );
		}
	}
	
	private void removeArea( ServletRequest request, DynamicMap map ) 
					 throws ServletException, DynamicMapException 
	{
		String szUniqueID = request.getParameter( Constants.AREA_PARAM_UNIQUE_ID );

		if ( szUniqueID == null ) {
			throw new ServletException( "Insufficient arguments to remove an area" );
		}

		long lUniqueID = 0;
		try {
			lUniqueID = Long.parseLong( szUniqueID );
		} catch ( NumberFormatException e ) { 		
			throw new ServletException( "Invalid position arguments while removing an area: " + e.getMessage( ) );
		}

		System.out.println( "Removing the area ID: " + lUniqueID );
		map.removeAreaByUniqueID( lUniqueID );
	}
}
