package lib.utils;

/**
 * @class lib.utils
 * 
 * A simple profiling interface
 * 
 * @author root
 * @date   May 15, 2005
 */
public class Profiler {
	long m_iStartTime = 0;

	public Profiler( ) { }

	/**
	 * Starts the profiler
	 */	
	public void start( ) 
	{
		m_iStartTime = System.currentTimeMillis( );
	}

	/**
	 * Stops the profiler
	 * 
	 * @return the profiled time in milliseconds
	 */	
	public long stop( ) 
	{
		return System.currentTimeMillis( ) - m_iStartTime;
	}
	
	/**
	 * Converts a given time from milliseconds to a human readable
	 * string 
	 * 
	 * @param time - the time in milliseconds
	 * 
	 * @return
	 */
	public String format( long time )
	{
		long seconds = time / 1000;
		long ms      = time % 1000;
		
		String szReturn = "";
		
		if ( seconds > 0 ) {
			szReturn += seconds + "sec ";
		}
		if ( ms > 0 ) {
			szReturn += ms + "msec";
		}
		
		return szReturn;
	}
}
