package lib.utils;

/**
 * @class lib.utils
 * 
 * Defines a class that allows management of a process progress
 * 
 * @author Tihomir Lazarov
 * @date   May 27, 2005
 */
public class Progress {
	//	The current step
	private long m_lCurrentStep		= 0;
	// All steps in the process
	private long m_lAllSteps			= 0;
	// The size of a single step 
	private long m_lStepSize			= 0;
		
	/**
	 * Gets the current progress in percents
	 */
	public int getProgress() {
		return ( int )Math.round( ( m_lCurrentStep / ( double )m_lAllSteps ) * 100.0f );
	}

	/**
	 * Initializes the progress bar
	 */
	public void init( long lAllSteps, long lStepSize ) {
		m_lAllSteps	= lAllSteps;
		m_lStepSize = lStepSize;
		reset( );
	}

	/**
	 * Resets the progress bar
	 */
	public void reset( ) {
		m_lCurrentStep = 0;
	}

	/**
	 * Steps forward with m_lStepSize units
	 */
	public void step( ) {
		m_lCurrentStep += m_lStepSize;
	}	
}
