/*
 * Created on Jul 21, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package test;

import java.io.*;
import java.awt.image.*;
import lib.map.base.Map;
import lib.encoder.ImageEncoder;
import lib.exceptions.MapStateException;
import lib.exceptions.NullMapException;

/**
 * @author root
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class BigImageTest {
	
	Map state = null;
	String szOutputFileName = "output.jpg";
	BufferedReader stdin = new BufferedReader( new InputStreamReader( System.in ) );
	String m_szXmlDefinition = "";
	
	public BigImageTest( String szXmlDefinition ) {
		m_szXmlDefinition = szXmlDefinition;
	}
	
	public void doTest( ) {
		
		/*
		ImageEncoder enc = new ImageEncoder( );
		
		try {
			state = new Map( 400, 300, m_szXmlDefinition );
			
			while ( true ) {
				System.out.println( "\n\n -------------------------- \n" );
				System.out.print( "Zoom (z), Navigate (n): ");
				BufferedImage result;
				String answer = stdin.readLine( );
				switch ( answer.charAt( 0 ) ) {
					case 'z':
						doZoom( );
						break;
					case 'n':
						doNavigate( );
						break;
					default:
						System.out.println( "Invalid command" );
						continue;
				}
				
				System.out.println( "Result in " + szOutputFileName );
			}
		} catch ( MapStateException e ) {
			System.out.println( "Map state exception: " + e.getMessage( ) );
		} catch ( IOException e ) {
			System.out.println( "I/O exception:" + e.getMessage( ) );
		}
		*/
	}
	
	public void doZoom( ) {
		try {
		
			if ( !state.isZoomable( Map.ZOOM_IN ) ) {
				System.out.println( "ZOOM_IN is not allowed" );
			}
			if ( !state.isZoomable( Map.ZOOM_OUT ) ) {
				System.out.println( "ZOOM_OUT is not allowed" );
			}
			
			System.out.print( "In (i) or Out (o): ");
	
			ImageEncoder enc = new ImageEncoder( );		
			String zoomTypeInput = stdin.readLine( );
			BufferedImage result = null;
			int zoomType;
			
			switch ( zoomTypeInput.charAt( 0 ) ) {
				case 'i':
					zoomType = Map.ZOOM_IN;
					break;
				case 'o':
					zoomType = Map.ZOOM_OUT;
					break;
				default:
					System.out.println( "Invalid zoom type: " + zoomTypeInput );
					return;
			}
			
			state.zoom( zoomType );
			result = state.getViewableRegionSnapshot( );
			enc.JPEGEncode( result, szOutputFileName );
			
		} catch ( NullMapException e ) {
			System.out.println( "Null map image exception: " + e.getMessage( ) );
		} catch ( MapStateException e ) {
			System.out.println( "Map state exception: " + e.getMessage( ) );
		} catch ( IOException e ) {
			System.out.println( "I/O exception:" + e.getMessage( ) );
		}
	}
	
	public void doNavigate( ) {
		try {
			if ( !state.isTranslateable( Map.TRANS_DIR_LEFT ) ) {
				System.out.println( "LEFT translation is not allowed" );
			}
			if ( !state.isTranslateable( Map.TRANS_DIR_RIGHT ) ) {
				System.out.println( "RIGHT translation is not allowed" );
			}
			if ( !state.isTranslateable( Map.TRANS_DIR_UP ) ) {
				System.out.println( "UP translation is not allowed" );
			}
			if ( !state.isTranslateable( Map.TRANS_DIR_DOWN ) ) {
				System.out.println( "DOWN translation is not allowed" );
			}
			
			System.out.print( "Left (l), Right (r), Up (u), Down (d), Numeric (n): ");
			String directionInput = stdin.readLine( );
			int direction = Map.TRANS_DIR_LEFT;
			int iOffsetX = 0;
			int iOffsetY = 0;
			
			switch ( directionInput.charAt( 0 ) ) {
				case 'l':
					direction = Map.TRANS_DIR_LEFT;
					break;
				case 'r':
					direction = Map.TRANS_DIR_RIGHT;
					break;
				case 'u':
					direction = Map.TRANS_DIR_UP;
					break;
				case 'd':
					direction = Map.TRANS_DIR_DOWN;
					break;
				case 'n':
					System.out.println( "Offset X: " );
					String offsetX = stdin.readLine( );
					System.out.println( "Offset Y: " );
					String offsetY = stdin.readLine( );
					iOffsetX = Integer.parseInt( offsetX );
					iOffsetY = Integer.parseInt( offsetY );
					break; 
				default:
					System.out.println( "Invalid direction: " + directionInput ); 
					return;
			}
			
			if ( directionInput.charAt( 0 ) != 'n' ) {
				state.translate( direction );
			} else {
				state.translateWithOffset( iOffsetX, iOffsetY );
			}
			
			BufferedImage result = state.getViewableRegionSnapshot( );
			ImageEncoder enc = new ImageEncoder( );
			enc.JPEGEncode( result, szOutputFileName );
			
		} catch ( IOException e ) {
			System.out.println( "I/O exception: " + e.getMessage( ) );
		} catch ( MapStateException e ) {
			System.out.println( "Map state exception: " + e.getMessage( ) );
		} catch ( NullMapException e ) {
			System.out.println( "Null map image exception: " + e.getMessage( ) );
		}
	}
	
	public static void main(String[] args) {
		if ( args.length != 1 ) {
			System.out.println( "Usage: java BigImageTest <Path/to/zooms.xml>");
			return;
		}
		BigImageTest test = new BigImageTest( args[ 0 ] );
		test.doTest( );
	}
	
}
