/*
 * Created on May 7, 2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package test;

import java.io.IOException;
import java.awt.Point;

/**
 * @class test
 * 
 * ...Module description...
 * 
 * @author root
 * @date   May 7, 2005
 */
public class Labyrinth {
	
	static void dumpLabyrinth( int[][] labyrinth, int x, int y )
	{
		for ( int i = 0; i < 1000; i++ ) {
			System.out.print( "\b" );
		}
		System.out.flush( );
		System.out.println( "" );
		
		for ( int i = 0; i < labyrinth.length; i++ ) {
			for ( int j = 0; j < labyrinth[ 0 ].length; j++ ) {
				String sign = "#";
				switch ( labyrinth[ i ][ j ] ) 
				{
					case 0: sign = "###"; break;
					case 1: sign = "---"; break;
					case 2: sign = "( )"; break;
				}
				if ( i == x && j == y ) {
					sign = "$$$";
				}
				
				System.out.print( sign );
			}
			System.out.println( "" );
		}
		System.out.println( "" );
	}
	
	static Point goToDirection( int[][] labyrinth, int x, int y, int dirs[], int dir )
	{
		int iPosition = dirs[ dir ];
		int iXOffset  = ( iPosition / 3 ) - 1;
		int iYOffset  = ( iPosition % 3 ) - 1;
				
		int iNewX = x + iXOffset;
		int iNewY = y + iYOffset;

		System.out.println( "* (" + x + "," + y + ") => " + iPosition + " => (" + iNewX + "," + iNewY + ")" );
				
		if ( iNewX >= 0 && iNewX < labyrinth.length &&
			 iNewY >= 0 && iNewY < labyrinth[ 0 ].length ) {
			if ( labyrinth[ iNewX ][ iNewY ] == 1 ) {
				Point p = new Point( iNewX, iNewY );
				return p;
			} 
		}
		
		return null;
	}
	
	static void goOut( int[][] labyrinth, int x, int y, int endX, int endY )
	{
		/**
		 * 0 1 2 
		 * 3 4 5
		 * 6 7 8
		 */
		int[] directions = {
			5, 8, 7, 6, 3, 0, 1, 2,
		};
		
		int iReturnTimes    		= 0;
		int iCurrentX       		= x;
		int iCurrentY       		= y;
		int iLastX          		= x;
		int iLastY          		= y;
		int iLastDirectionIndex = 0;
		while ( iReturnTimes < 8 ) {
			System.out.println( "Checking for exit..." );
			
			if ( iCurrentX == endX && iCurrentY == endY ) {
				dumpLabyrinth( labyrinth, iCurrentX, iCurrentY );
				return;
			}
			
			System.out.println( "Trying to find a direction with a wall on the right" );
			
			// Try to go right first
			int iDirectionIndex1 = ( iLastDirectionIndex + 1 ) % directions.length;
			int iDirectionIndex2 = ( iLastDirectionIndex + 2 ) % directions.length;
			Point wayPoint1  = goToDirection( labyrinth, iCurrentX, iCurrentY, directions, iDirectionIndex1 );
			Point wayPoint2  = goToDirection( labyrinth, iCurrentX, iCurrentY, directions, iDirectionIndex2 );
			if ( wayPoint1 != null || wayPoint2 != null ) {
				System.out.println( "Yes. There's a spot on the right. Going this way." );
				Point wayPoint = wayPoint1 != null ? wayPoint1 : wayPoint2;
				iLastDirectionIndex = wayPoint1 != null ? iDirectionIndex1 : iDirectionIndex2;
				iCurrentX = wayPoint.x;
				iCurrentY = wayPoint.y;
			} else {
				// Try the same direction or roate to the LEFT until you get a way to go
				System.out.println( "Trying the same direction + rotation on the LEFT if it doesn't work" );
				iDirectionIndex1 = iLastDirectionIndex;
				while ( true ) {
					Point p = goToDirection( labyrinth, iCurrentX, iCurrentY, directions, iDirectionIndex1 );
					if ( p != null ) {
						iLastDirectionIndex = iDirectionIndex1;
						iCurrentX = p.x;
						iCurrentY = p.y;
						break;
					}
					System.out.println( "Rotating..." );
					iDirectionIndex1 = ( iDirectionIndex1 - 1 + directions.length ) % directions.length;
				}
			}
			
			dumpLabyrinth( labyrinth, iCurrentX, iCurrentY );
			try {
				System.out.print( "Press any key to continue..." );
				System.out.flush( );
				System.in.read();
			} catch ( IOException e ) {
				return;
			}
			
			
			System.out.println( "Checking if we're back again" );
			
			if ( iCurrentX == x && iCurrentY == y ) { 
				iReturnTimes++;
			}
		}
		dumpLabyrinth( labyrinth, iCurrentX, iCurrentY );
		System.out.println( "Cannot go out!" );
	}

	public static void main(String[] args) {
		int[][] labyrinth = {
			{ 0, 0, 0, 0, 1, 0, 0 },
			{ 0, 1, 1, 1, 1, 1, 0 },
			{ 1, 0, 0, 0, 0, 1, 0 },
			{ 0, 1, 0, 0, 1, 0, 0 },
			{ 0, 1, 0, 1, 0, 0, 0 },
			{ 0, 1, 1, 0, 0, 0, 0 },
			{ 0, 0, 0, 0, 0, 0, 0 },
		};
		
		goOut( labyrinth, 4, 3, 2, 0 );
	}
}
